	Title - BaseAddress - assembler implementation of GRAPHIX routine
;TS8,16,24,32,40,48,56,64,72
	include	model.h
	include	prologue.h

	public	BaseAddress

BAY	equ	@ab[bp]


BaseAddress	proc	near

	push	bp
	mov	bp,sp

	mov	ax,BAY			;get row address
	mov	ah,al			;duplicate address in AH
	and	ax,01FEh		;mask AX to get rid of unwanted data
					;  AH = row mod 2
					;  AL = 2 * (row \ 2)
	sal	ax,1			;*4
	sal	ax,1			;*8
	sal	ax,1			;*16
	mov	bx,ax			;store 16 multiple
	and	bh,7			;  lower byte register only
	sal	ax,1			;*32
	sal	ax,1			;*64
	add	ax,bx			;combine multiples to get offset

	pop	bp
	ret

BaseAddress	endp

	include	epilogue.h

	end

