/*
	definitions for portable CORE graphics routines
*/


/*	variables holding the "current position" in world coordinates	*/

extern double cur_x,cur_y,cur_z;


/*	indirectly defined routines		*/

#define	line_abs_2(x,y)			line_abs_3((x),(y),cur_z)
#define	line_rel_2(dx,dy)		line_abs_3((dx)+cur_x,(dy)+cur_y,cur_z)
#define	line_rel_3(dx,dy,dz)	line_abs_3((dx)+cur_x,(dy)+cur_y,(dz)+cur_z)
#define	marker_abs_2(x,y)		marker_abs_3((x),(y),cur_z)
#define	marker_rel_2(x,y)		marker_abs_3((x)+cur_x,(y)+cur_y,cur_z)
#define	marker_rel_3(x,y,z)		marker_abs_3((x)+cur_x,(y)+cur_y,(z)+cur_z)
#define	move_abs_2(x,y)			move_abs_3((x),(y),cur_z)
#define	move_rel_2(dx,dy)		move_abs_3((dx)+cur_x,(dy)+cur_y,cur_z)
#define	move_rel_3(dx,dy,dz)	move_abs_3((dx)+cur_x,(dy)+cur_y,(dz)+cur_z)
#define viewport2(x1,x2,y1,y2)	viewport3((x1),(x2),(y1),(y2),0.,1.)


/*	predefined line types	*/

#define SOLID 0
#define DASHED 1
#define DOTTED 2
#define DASHDOT 3
