extern int    fg_allocate (int);
extern int    fg_automode (void);

extern int    fg_bestmode (int, int, int);
extern int    fg_button (int);

extern int    fg_capslock (void);
extern void   fg_chgattr (int);
extern void   fg_chgtext (char *, int);
extern void   fg_circle (int);
extern void   fg_circlew (double);
extern void   fg_clipmask (char *, int, int);
extern void   fg_clpimage (char *, int, int);
extern void   fg_clprect (int, int, int, int);
extern void   fg_clprectw (double, double, double, double);
extern void   fg_cursor (int);

extern void   fg_dash (int, int, int);
extern void   fg_dashrel (int, int, int);
extern void   fg_dashrw (double, double, int);
extern void   fg_dashw (double, double, int);
extern void   fg_defcolor (int, int);
extern void   fg_dispfile (char *, int, int);
extern void   fg_display (char *, int, int);
extern void   fg_displayp (char *, int, int);
extern void   fg_draw (int, int);
extern void   fg_drawmap (char *, int, int);
extern void   fg_drawmask (char *, int, int);
extern void   fg_drawrel (int, int);
extern void   fg_drawrw (double, double);
extern void   fg_draww (double, double);
extern void   fg_drect (int, int, int, int, char *);
extern void   fg_drectw (double, double, double, double, char *);
extern void   fg_drwimage (char *, int, int);

extern int    fg_egacheck (void);
extern void   fg_ellipse (int, int);
extern void   fg_ellipsew (double, double);
extern void   fg_erase (void);

extern void   fg_fadein (int);
extern void   fg_fadeout (int);
extern void   fg_flipmask (char *, int, int);
extern void   fg_flpimage (char *, int, int);
extern int    fg_freepage (int);

extern int    fg_getaddr (void);
extern long   fg_getclock (void);
extern int    fg_getcolor (void);
extern int    fg_gethpage (void);
extern void   fg_getimage (char *, int, int);
extern int    fg_getindex (int);
extern void   fg_getkey (unsigned char *, unsigned char *);
extern void   fg_getmap (char *, int, int);
extern int    fg_getmaxx (void);
extern int    fg_getmaxy (void);
extern int    fg_getmode (void);
extern int    fg_getpage (void);
extern int    fg_getpixel (int, int);
extern void   fg_getrgb (int, int *, int *, int *);
extern int    fg_getvpage (void);
extern void   fg_getworld (double *, double *, double *, double *);
extern int    fg_getxjoy (int);
extern int    fg_getxpos (void);
extern int    fg_getyjoy (int);
extern int    fg_getypos (void);

extern void   fg_hush (void);
extern void   fg_hushnext (void);

extern int    fg_initjoy (int);
extern void   fg_initw (void);
extern void   fg_intjoy (int, char *, char *);
extern void   fg_intkey (unsigned char *, unsigned char *);

extern void   fg_locate (int, int);

extern int    fg_measure (void);
extern long   fg_memavail (void);
extern void   fg_mousebut (int, int *, int *, int *);
extern void   fg_mousecur (int, int);
extern int    fg_mouseini (void);
extern void   fg_mouselim (int, int, int, int);
extern void   fg_mousemov (int, int);
extern void   fg_mousepos (int *, int *, int *);
extern void   fg_mouseptr (int *, int, int);
extern void   fg_mousespd (int, int);
extern void   fg_mousevis (int);
extern void   fg_move (int, int);
extern void   fg_moverel (int, int);
extern void   fg_moverw (double, double);
extern void   fg_movew (double, double);
extern void   fg_music (char *);
extern void   fg_musicb (char *, int);

extern int    fg_numlock (void);

extern void   fg_paint (int, int);
extern void   fg_paintw (double, double);
extern void   fg_palette (int, int);
extern void   fg_palettes (int *);
extern void   fg_pan (int, int);
extern void   fg_panw (double, double);
extern void   fg_pattern (int, int);
extern int    fg_playing (void);
extern void   fg_point (int, int);
extern void   fg_pointw (double, double);
extern void   fg_polygon (int *, int *, int);
extern void   fg_polygonw (double *, double *, int);

extern void   fg_quiet (void);

extern void   fg_rect (int, int, int, int);
extern void   fg_rectw (double, double, double, double);
extern void   fg_reset (void);
extern void   fg_restore (int, int, int, int);
extern void   fg_restorew (double, double, double, double);
extern void   fg_revimage (char *, int, int);
extern void   fg_revmask (char *, int, int);

extern void   fg_save (int, int, int, int);
extern void   fg_savew (double, double, double, double);
extern int    fg_scrlock (void);
extern void   fg_scroll (int, int, int, int, int, int);
extern void   fg_setangle (double);
extern void   fg_setattr (int, int, int);
extern void   fg_setcaps (int);
extern void   fg_setclip (int, int, int, int);
extern void   fg_setclipw (double, double, double, double);
extern void   fg_setcolor (int);
extern void   fg_setfunc (int);
extern void   fg_sethpage (int);
extern void   fg_setmode (int);
extern void   fg_setnum (int);
extern void   fg_setpage (int);
extern void   fg_setratio (double);
extern void   fg_setrgb (int, int, int, int);
extern void   fg_setsize (int);
extern void   fg_setsizew (double);
extern void   fg_setvpage (int);
extern void   fg_setworld (double, double, double, double);
extern void   fg_sound (int, int);
extern void   fg_sounds (int *, int);
extern void   fg_stall (int);
extern void   fg_swchar (char *, int, int);
extern double fg_swlength (char *, int);
extern void   fg_swtext (char *, int, int);

extern void   fg_tcmask (int);
extern void   fg_tcxfer (int, int, int, int, int, int, int, int);
extern int    fg_testmode (int, int);
extern void   fg_text (char *, int);
extern void   fg_transfer (int, int, int, int, int, int, int, int);

extern void   fg_version (int *, int *);
extern void   fg_voice (int, int, int, int);
extern void   fg_voices (int *, int);

extern void   fg_waitfor (int);
extern void   fg_waitkey (void);
extern void   fg_where (int *, int *);

extern int    fg_xalpha (int);
extern int    fg_xconvert (int);
extern int    fg_xscreen (double);
extern double fg_xworld (int);

extern int    fg_yalpha (int);
extern int    fg_yconvert (int);
extern int    fg_yscreen (double);
extern double fg_yworld (int);
