/*
 *  xgif.h  -  header file for xgif, but you probably already knew as much
 */


#define REVDATE   "Rev: 2/13/89"
#define MAXEXPAND 16

/* include files */
#include <stdio.h>
#include <math.h>
#include <ctype.h>

#ifndef MAIN
#define WHERE extern
#else
#define WHERE
#endif

typedef unsigned char byte;

#define CENTERX(f,x,str) ((x)-XTextWidth(f,str,strlen(str))/2)
#define CENTERY(f,y) ((y)-((f->ascent+f->descent)/2)+f->ascent)


/* global vars */
WHERE int            iWIDE,iHIGH,eWIDE,eHIGH,expand,numcols,strip,nostrip;
WHERE unsigned long  cols[256];
WHERE char          *cmd;

#define	FatalError(s)	{fprintf(stderr,"Fatal Error: %s\n",(s)); exit(1);}
#define	False	0
#define	True	1

#define		TSENG		0
#define		VIDEO7		1
#define		PARADISE	2
#define		EVEREX		3
#define		GENERIC		4
#define		LWIDTH		320
#define		LHEIGHT		200
#define		MWIDTH		640
#define		MHEIGHT		480
#define		HWIDTH		800
#define		HHEIGHT		600
#define		VHWIDTH		1024
#define		VHHEIGHT	768
#define		UHWIDTH		1280
#define		UHEIGHT		1024

struct overlay {
    int             off;
    short           seg;
};

int	set_device(char d);



